admin = new Object();

admin.current_question = -1;
admin.current_points = 0;

admin.player1 = new Object();
admin.player1.name = "Õpetajad";
admin.player1.points = 0;

admin.player2 = new Object();
admin.player2.name = "Õpilased";
admin.player2.points = 0;

$(function(){
    admin.start();
});


admin.sg = function (data) {
    // send wbsocet data
    data.type="game"
    admin.ws.send(JSON.stringify(data)+"\n\n\n")
}

admin.sgdt = function (div_name, div_text) {
    admin.sg({"action":"set-div-text", "div_name":div_name, "div_text": div_text})
}

admin.start = function () {
    console.log("start")
    admin.ws = new ReconnectingWebSocket('ws://'+window.location.host+'/ws');
    admin.ws.onopen = function (event) {
        console.log("WebSocket connected")
        $.getJSON( "/questions", function( data ) {
            admin.questions = data.questions;
            console.log("questions downloaded");
            //admin.show_question(admin.current_question);
        });
        $("#player1-name").text(admin.player1.name);
        admin.sgdt("#player1-name", admin.player1.name)
        $("#player2-name").text(admin.player2.name);
        admin.sgdt("#player2-name", admin.player2.name)
    };

    admin.ws.onmessage = function(event) {
        var all_msgs = event.data.split("\n\n\n")
        console.log(all_msgs);
        for (msg in all_msgs) {
            if (all_msgs[msg].length>0) {

        var msg = JSON.parse(all_msgs[msg]);
        switch (msg.type) {
            case "vote":
                console.log("vote")
                if (msg.team_name === admin.player1.name){
                    if ($("#player2").css("background-color") != "rgb(255, 0, 0)") {
                        $("#player1").css("background-color", "red");
                        setTimeout(function() { $("#player1").css("background-color", "white") },2000);
                        console.log("player2 won: %s", $("#player2").css("background-color"));
                    } else {
                        console.log("player1 was too late");
                    }
                } else if (msg.team_name === admin.player2.name) {
                    if ($("#player1").css("background-color") != "rgb(255, 0, 0)") {
                        $("#player2").css("background-color", "red");
                        setTimeout(function() { $("#player2").css("background-color", "white") },2000);
                        console.log("player2 won: %s", $("#player2").css("background-color"));
                    } else {
                        console.log("player2 was too late");
                    }
                }
                break
            case "status":
                if (msg.status === "ready") {
                    if (msg.team_name === admin.player1.name){
                        $("#player1").css("background-color", "green");
                        setTimeout(function() { $("#player1").css("background-color", "white") },500);

                    } else if (msg.team_name === admin.player2.name) {
                        $("#player2").css("background-color", "green");
                        setTimeout(function() { $("#player2").css("background-color", "white") },500);
                    }
                }
                break
        }            }    
        }

        //console.log("got a message: %s", event.data)
    }
    $("#prev-question").on("click", function () {
        console.log("prev-question");
        admin.current_question -= 1
        admin.show_question(admin.current_question);
    });
    $("#next-question").on("click", function () {
        console.log("next-question");
        admin.current_question += 1
        admin.show_question(admin.current_question);
    });
    for (var i = 0; i < 6; i++) {
        $("#answer-"+i).data("answer-id", i)
        $("#answer-"+i).on("click", function () {
            console.log($(this).css("background-color"))
            if ($(this).css("background-color") === "rgb(124, 252, 0)") {
                return;
            }
            var points = parseInt($(this).data("points"))
            if (admin.current_question < 2) {
                points = points
                $("#multiplier").text("1x");
                admin.sgdt("#multiplier", "1x");
            } else if (admin.current_question > 1 && admin.current_question < 3) {
                points = points * 2
                $("#multiplier").text("2x");
                admin.sgdt("#multiplier", "2x");
            } else if (admin.current_question > 2) {
                points = points * 3
                $("#multiplier").text("3x");
                admin.sgdt("#multiplier", "3x");
            }
            admin.current_points += points;
            
            $("#points").text(admin.current_points);
            admin.sgdt("#points", admin.current_points);
            $(this).css("background-color", "LawnGreen");
            var aid = $(this).data("answer-id")
            admin.sgdt("#answer-"+aid+"-answer", $(this).data("answer"));
            admin.sgdt("#answer-"+aid+"-points", $(this).data("points"));
        });
    }
    $("#lives div").on("click", function () {
        console.log("life %s", $(this).attr('id'))
        $(this).css("background-color", "red");
    });

    $("#player1").on("mousedown", function () {$(this).css("background-color", "LawnGreen");});
    $("#player2").on("mousedown", function () {$(this).css("background-color", "LawnGreen");});
    $("#player1").on("click", function () {
        $(this).css("background-color", "white");
        admin.player1.points += admin.current_points;
        admin.current_points = 0;
        $("#points").text(admin.current_points);
        admin.sgdt("#points", admin.current_points);
        $("#player1-points").text(admin.player1.points);
        admin.sgdt("#player1-points", admin.player1.points);
    });
    $("#player2").on("click", function () {
        $(this).css("background-color", "white");
        admin.player2.points += admin.current_points;
        admin.current_points = 0;
        $("#points").text(admin.current_points);
        admin.sgdt("#points", admin.current_points);
        $("#player2-points").text(admin.player2.points);
        admin.sgdt("#player2-points", admin.player2.points);
    });
}

admin.show_question = function (question_nr) {
    console.log("showing question %d", question_nr);
    $("#question").text(question_nr+1+". "+admin.questions[question_nr].question)
    admin.sgdt("#question", question_nr+1+". "+admin.questions[question_nr].question);
    // reset elements
    for (var i = 0; i < 6; i++) {
        $("#answer-"+i+"-answer").text(" ");
        $("#answer-"+i+"-points").text(" ");
        $("#answer-"+i).data("points", "");
        $("#answer-"+i).data("answer", "");
        $("#answer-"+i).css("background-color", "white");
        admin.sgdt("#answer-"+i+"-points", "");
        admin.sgdt("#answer-"+i+"-answer", i+1);
    };
    $("#lives div").css("background-color", "white")
    admin.current_points = 0;
    $("#points").text(admin.current_points);
    admin.sgdt("#points", ""+admin.current_points);

    if (admin.current_question < 2) {
        $("#multiplier").text("1x");
        admin.sgdt("#multiplier", "1x");
    } else if (admin.current_question > 1 && admin.current_question < 3) {
        $("#multiplier").text("2x");
        admin.sgdt("#multiplier", "2x");
    } else if (admin.current_question > 2) {
        $("#multiplier").text("3x");
        admin.sgdt("#multiplier", "3x");
}


    for (answer_nr in admin.questions[question_nr].answers) {
        var answer = admin.questions[question_nr].answers[answer_nr];
        console.log(answer);
        $("#answer-"+answer_nr+"-answer").text(answer.answer);
        $("#answer-"+answer_nr).data("answer", answer.answer);
        $("#answer-"+answer_nr+"-points").text(answer.score);
        $("#answer-"+answer_nr).data("points", answer.score);
    }
}