game = new Object();

$(function(){
    game.start();
});

game.start = function () {
    console.log("start")
    game.ws = new ReconnectingWebSocket('ws://'+window.location.host+'/ws');
    game.ws.onopen = function (event) {
        console.log("we got connection")
    };
    game.ws.onmessage = function(event) {
        console.log("got a message: %s", event.data)
        var all_msgs = event.data.split("\n\n\n")
        console.log(all_msgs);
        for (msg in all_msgs) {
            if (all_msgs[msg].length>0) {

                var msg = JSON.parse(all_msgs[msg]);
                if (msg.type === "game") {
                    console.log("got game message with action %s", msg.action)
                    if (msg.action === "set-div-text") {
                        $(msg.div_name).text(msg.div_text)
                    }
                }
            }
        }
    }
}