player = new Object();

$(function(){
    player.start();
});

player.start = function () {
    player.ws = new ReconnectingWebSocket('ws://'+window.location.host+'/ws');
    player.bigbutton = $("#bigbutton")
    player.bigbutton.on("touchstart", player.vote_start);
    player.bigbutton.on("toucend", player.vote_end);
    player.bigbutton.on("touchcancel", player.vote_end);
    player.bigbutton.on("touchleave", player.vote_end);
    player.bigbutton.on("mousedown", player.vote_start);
    player.bigbutton.on("mouseup", player.vote_end);
    $(document).keydown(player.vote_start);
    $(document).keyup(player.vote_end);
    player.team_name = player.bigbutton.data("team-name")
    console.log("team-name: %s", player.team_name)
    
    player.ws.onopen = function (event) {
        console.log("we got connection")
        //console.dir(event)
        player.ws.send(JSON.stringify({type:"status", 
                                        team_name:player.team_name,
                                        status: "ready",
                                    }));
    };
    player.ws.onmessage = function(event) {
        var msg = JSON.parse(event.data);
        if (msg.type === "vote" && 
            msg.team_name === player.team_name && 
            msg.vote_id != player.last_vote_id) {
            player.bigbutton.css("background-color", "black");
            setTimeout(function() { player.bigbutton.css("background-color", "red") },100);
        }
        console.log("got a message: %s", event.data)
    }

}

player.vote_start = function () {
    console.log("vote_start");
    player.last_vote_id = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
        var r = Math.random()*16|0, v = c == 'x' ? r : (r&0x3|0x8);
        return v.toString(16);
    });
    player.ws.send(JSON.stringify({type:"vote",
                                    team_name:player.team_name,
                                    vote_id: player.last_vote_id
                                }));
    player.bigbutton.css("background-color", "black");
}

player.vote_end = function () {
    console.log("vote_end");
    player.bigbutton.css("background-color", "red");
}
