import uwsgi
import json
import time
print("ws serv loaded")

def application(env, sr):
    print("ws serv got request")
    print(env['HTTP_SEC_WEBSOCKET_KEY'])
    uwsgi.websocket_handshake(env['HTTP_SEC_WEBSOCKET_KEY'], env.get('HTTP_ORIGIN', ''))
    print("websockets...")
    msg_srv_fd = uwsgi.async_connect("127.0.0.1:2123")
    websocket_fd = uwsgi.connection_fd()
    while True:
        uwsgi.wait_fd_read(websocket_fd, 3)
        uwsgi.wait_fd_read(msg_srv_fd)
        uwsgi.suspend()
        fd = uwsgi.ready_fd()
        if fd > -1:
            if fd == websocket_fd:
                msg = uwsgi.websocket_recv_nb()
                if msg and len(msg):
                    #msg = json.loads(msg.decode("utf-8"))
                    #msg["receive_time"] = time.time()
                    print("got message over ws: {}".format(str(msg)))
                    uwsgi.send(msg_srv_fd, msg)# json.dumps(msg).encode("utf-8"))

            elif fd == msg_srv_fd:
                msg = uwsgi.recv(msg_srv_fd)
                print("got message over msg_srv: {}".format(msg))
                uwsgi.websocket_send(msg)
        else:
            # on timeout call websocket_recv_nb again to manage ping/pong
            msg = uwsgi.websocket_recv_nb()
            print("ws ping/pong")
            if msg and len(msg):
                #msg = json.loads(msg.decode("utf-8"))
                #msg["receive_time"] = time.time()
                print("got message over ws: {}".format(str(msg)))
                uwsgi.send(msg_srv_fd, msg)#json.dumps(msg).encode("utf-8"))
